*****************
* LHAPDF version*
*****************

      subroutine pdfset
      implicit none
      integer flagalphas,mem,Nmem,order
      character name*64
      double precision alphasPDF,QMZ,amz
      include 'masses.f'
      include 'nlooprun.f'
      include 'ewinput.f'
      common/name/name
      common/mem/mem
      common/nnlo/order
      common/couple/amz

      write(*,*)'CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC'
      write(*,*)'C                                                  C'
      write(*,*)'C        HRes running with LHAPDF routines         C'
      write(*,*)'C                                                  C'
      write(*,*)'CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC'
      write(*,*)'C                                                  C'
      write (6,48)' C   ',name,', mem=',mem,'             C'
  48  format(A,A25,A,I3,A)
      write (*,*)'C                                                  C'
      write(*,*)'CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC'
      write(*,*)

      call InitPDFsetByName(name)

      call numberPDF(Nmem)
      if(mem.gt.Nmem) then
          write(*,*)'input mem out of range!!!'
          stop
      endif

      call InitPDF(mem)
      zmass=zmass_inp
      amz=alphasPDF(zmass)
      nlooprun=order+1


      end
