      subroutine genCT4(q2,qt2,y34,r,p,wt,*)
C     Generate event for the counterterm given q2,qt2,y34
      implicit none
      include 'constants.f'
      include 'mxdim.f'
      include 'phasemin.f'
      include 'masses.f'
      integer nu

      double precision r(mxdim),wt34,wt56,wt3456,wt,p(mxpart,4)
     . ,p12(4),p34(4),p56(4),p3(4),p4(4),p5(4),p6(4)
     . ,p1(4),p2(4),wt0
      double precision pswt,xjac,q2,qt2,qt,y34,phi,mmt
      parameter(wt0=1d0/twopi**2)

      wt=0d0

      phi=twopi*r(3)

      mmt=dsqrt(q2+qt2)
      qt=dsqrt(qt2)
      p12(1)=qt*dcos(phi)
      p12(2)=qt*dsin(phi)
      p12(3)=0.5d0*mmt*(dexp(y34)-dexp(-y34))
      p12(4)=0.5d0*mmt*(dexp(y34)+dexp(-y34))


      call phi1_2(r(1),r(2),r(3),r(4),p12,p56,p34,wt3456,*99)
      call phi3m0(r(7),r(8),p34,p3,p4,wt34,*99)
      call phi3m0(r(5),r(6),p56,p5,p6,wt56,*99)
      wt=wt3456*wt34*wt56

!      p1(1)=0d0
!      p1(2)=0d0
!      p1(3)=-hmass*dexp(y34)*0.5d0
!      p1(4)=p1(3)
!      p2(1)=-p12(1)
!      p2(2)=-p12(2)
!      p2(3)=-p12(3)-p1(3)
!      p2(4)=-p12(4)-p1(4)
!      call phase4(r,p1,p2,p3,p4,p5,p6,pswt,*99)
!      wt=pswt/wt0

      do nu=1,4
      p(1,nu)=p1(nu)
      p(2,nu)=p2(nu)
      p(3,nu)=p3(nu)
      p(4,nu)=p4(nu)
      p(5,nu)=p5(nu)
      p(6,nu)=p6(nu)
      enddo 

      return
 99   continue
      wt=0d0

      return
      end
