      subroutine phi4(r,p1,p3,p4,p5,p6,wt,*)
      implicit none
      include 'constants.f'
      include 'masses.f'
      include 'mxdim.f'
      include 'process.f'
c---- generate phase space for 1-->4 process
c---- r(mxdim),p1(4) are inputs
c---- from physical values
c---- phase space for p1 --> p3+p4+p5+p6
c---- with all 2 pi's (ie 1/(2*pi)^8) ?????
      double precision r(mxdim)
      double precision p1(4),p3(4),p4(4),p5(4),p6(4)
      double precision p34(4),p56(4) !,p12(4)
      double precision wt,wt3456,wt34,wt56,wt0
      integer j
      parameter(wt0=1d0/twopi**2)


! p1 decay into two massive particles p56 and p34
      call phi1_2(r(1),r(2),r(3),r(4),p1,p34,p56,wt3456,*99)
! now p34 and p56 decay into 4 massless particles
      call phi3m0(r(5),r(6),p34,p3,p4,wt34,*99)
      call phi3m0(r(7),r(8),p56,p5,p6,wt56,*99)

      wt=wt0*wt3456*wt34*wt56
      return


 99   wt=0d0
      return 1
      end
